
;Small Window with Menu and Located OFN Dialog, List View - DednDave, 2-2012

        .XCREF
        .NOLIST
        INCLUDE    \masm32\include\masm32rt.inc
        INCLUDE    SmallOFN.inc
        .LIST

;###############################################################################################

        .DATA

;------------------------------

;menu data

MenuTable        dd 4                                                       ;'File' menu
                 dd szOpen,IDM_FILE_OPEN,MF_STRING                          ;'Open'
                 dd szSaveAs,IDM_FILE_SAVEAS,MF_GRAYED                      ;'Save As...'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szExit,IDM_FILE_EXIT,MF_STRING                          ;'Exit'
                 dd szFileMenu                                              ;'File'

                 dd 2                                                       ;'Edit' menu
                 dd szCopyAll,IDM_EDIT_COPYALL,MF_GRAYED                    ;'Copy All'
                 dd szCopyForum,IDM_EDIT_COPYFORUM,MF_GRAYED                ;'Copy Forum'
                 dd szEditMenu                                              ;'Edit'

                 dd 6                                                       ;'View' menu
                 dd szForeColor,IDM_FORE_COLOR,MF_STRING                    ;'Foreground Color'
                 dd szBackColor,IDM_BACK_COLOR,MF_STRING                    ;'Background Color'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szSettings,IDM_SAVE_SETTINGS
ViewState        dd MF_STRING                                               ;'Save Settings'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szStatusBar,IDM_VIEW_STATUSBAR
StbState         dd STATUS_BAR                                              ;'Status Bar'
                 dd szViewMenu                                              ;'View'

                 dd 3                                                       ;'Help' menu
                 dd szHelpMenu,IDM_HELP_HELP,MF_STRING                      ;'Help'
                 dd NULL,NULL,MF_SEPARATOR                                  ;MFT_SEPARATOR
                 dd szAbout,IDM_HELP_ABOUT,MF_STRING                        ;'About'
                 dd szHelpMenu                                              ;'Help'

szFileMenu       db 'File',0
szEditMenu       db 'Edit',0
szViewMenu       db 'View',0
szHelpMenu       db 'Help',0
szOpen           db 'Open',0
szSaveAs         db 'Save As...',0
szExit           db 'Exit',0
szCopyAll        db 'Copy All',0
szCopyForum      db 'Copy Forum',0
szForeColor      db 'Foreground Color',0
szBackColor      db 'Background Color',0
szSettings       db 'Save View Settings',0
szStatusBar      db 'Status Bar',0
szAbout          db 'About',0

;------------------------------

szClassName      db 'SmallWindowClass',0
szAppName        db 'Small OFN',0
szWorkerClass    db 'WindowW',0

FileTypeStrs     db 'Text Files',0
szFileTypeExt    db '*.txt',0,'All Files',0,'*.*',0,0

;***********************************************************************************************

        .DATA?

        ALIGN   4

hInstance   dd ?
hWin        dd ?
hMenu       dd ?
hHeap       dd ?
hDlgPrev    dd ?
hDefView    dd ?
hOfnLv      dd ?
OfnFlag     dd ?

;------------------------------

;we use these EQUates as estimated position offsets to the first file name

OFN_OFS_X EQU 20
OFN_OFS_Y EQU 10

;used to acquire the mouse position, then locate the Open File dialog box

OfnCoord POINT <>
; x        dd ?
; y        dd ?

;used for the position of the Open File dialog box to calculate width and height

rc       RECT <>
; left     dd ?
; top      dd ?
; right    dd ?
; bottom   dd ?

;###############################################################################################

        .CODE

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

        ALIGN   16

WndProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

;------------------------------

        mov     ecx,[esp+8]                             ;ECX = uMsg
        cmp     ecx,WM_COMMAND
        jz      Cmmnd0

        cmp     ecx,WM_CLOSE
        jz      WndPrY

        cmp     ecx,WM_DESTROY
        jz      WndPrZ

;------------------------------

        JMP     DefWindowProc

;------------------------------

WndPr0: xor     eax,eax
        ret     16

;------------------------------

;WM_COMMAND

Cmmnd0: mov     eax,[esp+12]                            ;EAX = wParam
        cmp     eax,IDM_FILE_OPEN
        jz      CmmndB

        cmp     eax,IDM_FILE_EXIT
        jnz     WndPr0

;------------------------------

;IDM_FILE_EXIT

CmmndA: INVOKE  PostMessage,[esp+16],WM_SYSCOMMAND,SC_CLOSE,NULL
        jmp     WndPr0

;------------------------------

;IDM_FILE_OPEN

CmmndB: call    FOpen
        jmp     WndPr0

;------------------------------

;WM_CLOSE

WndPrY: INVOKE  DestroyWindow,[esp+4]                   ;hWnd
        jmp     WndPr0

;------------------------------

;WM_DESTROY

WndPrZ: INVOKE  PostQuitMessage,NULL
        jmp     WndPr0

;------------------------------

WndProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;***********************************************************************************************

FnAlloc PROC

;allocate temporary buffer for filenames

;  Returns: EAX = address of allocated block
;           ECX = 0
;           EDX = size of allocated block

        mov     edx,4096
        push    edx
        INVOKE  HeapAlloc,hHeap,HEAP_ZERO_MEMORY,edx
        xor     ecx,ecx
        pop     edx
        ret

FnAlloc ENDP

;***********************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

HFree   PROC    hBlock:HANDLE

;frees heap allocation

        INVOKE  HeapFree,hHeap,NULL,[esp+4]
        ret     4

HFree   ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;***********************************************************************************************

OfnDlgProc PROC hwndDlg:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        cmp     uMsg,WM_NOTIFY
        mov     edx,OfnFlag
        jnz     ODPr00

        inc     edx
        mov     eax,hwndDlg
        jnz     ODPr03

ODPr00: INVOKE  CallWindowProc,hDlgPrev,hwndDlg,uMsg,wParam,lParam
        ret

;search for listview control

ODPr01: INVOKE  FindWindowEx,hwndDlg,ebx,offset szWorkerClass,NULL
        or      eax,eax
        mov     ebx,eax
        jnz     ODPr04

ODPr02: pop     ebx
        jmp     ODPr00

ODPr03: push    ebx
        xor     ebx,ebx

ODPr04: INVOKE  GetDlgItem,eax,lst2
        or      eax,eax
        jz      ODPr01

        mov     hDefView,eax
        INVOKE  GetDlgItem,eax,1
        or      edx,-1
        or      eax,eax
        jz      ODPr01

;reposition open file dialog window

        push    esi
        push    edi
        mov     OfnFlag,edx
        mov     hOfnLv,eax
        mov     esi,offset rc
        mov     edi,offset OfnCoord
        mov     ebx,hwndDlg

        INVOKE  GetWindowRect,eax,esi
        INVOKE  GetCursorPos,edi
        mov     eax,[edi].POINT.y
        mov     ecx,[edi].POINT.x
        sub     eax,[esi].RECT.top
        sub     ecx,[esi].RECT.left
        sub     eax,OFN_OFS_Y
        sub     ecx,OFN_OFS_X
        push    eax
        push    ecx
        INVOKE  GetWindowRect,ebx,esi
        pop     edi
        pop     edx
        mov     eax,[esi].RECT.top
        mov     ecx,[esi].RECT.left
        add     edx,eax                                           ;EDX = Y
        add     edi,ecx                                           ;EDI = X
        sub     eax,[esi].RECT.bottom
        sub     ecx,[esi].RECT.right
        neg     eax                                               ;EAX = height
        neg     ecx                                               ;ECX = width
        INVOKE  MoveWindow,ebx,edi,edx,ecx,eax,TRUE

        INVOKE  ShowWindowAsync,ebx,SW_SHOW
        pop     edi
        pop     esi
        jmp     ODPr02

OfnDlgProc ENDP

;***********************************************************************************************

        OPTION  PROLOGUE:None
        OPTION  EPILOGUE:None

OFNProc PROC    hDlg:HWND,uiMsg:UINT,wParam:WPARAM,lParam:LPARAM

        cmp dword ptr [esp+8],WM_INITDIALOG               ;[esp+8] = uiMsg
        jz      OHook1

OHook0: xor     eax,eax
        ret     16

OHook1: INVOKE  GetParent,[esp+4]                         ;[esp+4] = hDlg
        push    eax
        INVOKE  ShowWindowAsync,eax,SW_HIDE
        pop     eax
        INVOKE  SetWindowLong,eax,DWL_DLGPROC,OfnDlgProc
        mov     hDlgPrev,eax
        jmp     OHook0

OFNProc ENDP

        OPTION  PROLOGUE:PrologueDef
        OPTION  EPILOGUE:EpilogueDef

;***********************************************************************************************

FOpen   PROC

;File Open dialog

;OPENFILENAME STRUCT
; lStructSize       dd ?
; hwndOwner         dd ?
; hInstance         dd ?
; lpstrFilter       dd ?
; lpstrCustomFilter dd ?
; nMaxCustFilter    dd ?
; nFilterIndex      dd ?
; lpstrFile         dd ?
; nMaxFile          dd ?
; lpstrFileTitle    dd ?
; nMaxFileTitle     dd ?
; lpstrInitialDir   dd ?
; lpstrTitle        dd ?
; Flags             dd ?
; nFileOffset       dw ?
; nFileExtension    dw ?
; lpstrDefExt       dd ?
; lCustData         dd ?
; lpfnHook          dd ?
; lpTemplateName    dd ?

        call    FnAlloc

;EAX = allocated address
;ECX = 0
;EDX = size of allocated block

        push    eax                                                      ;HFree:hBlock
        push    edx
        push    eax

        push    ecx                                                      ;lpTemplateName
        dec     edx
        push    OFNProc                                                  ;lpfnHook
        push    ecx                                                      ;lCustData
        push    ecx                                                      ;lpstrDefExt
        push    ecx                                                      ;nFileOffset/nFileExtension
        push    OFN_LONGNAMES or OFN_OVERWRITEPROMPT or OFN_ENABLEHOOK or OFN_EXPLORER ;Flags
        push    offset szOpen                                            ;lpstrTitle
        push    ecx                                                      ;lpstrInitialDir
        push    ecx                                                      ;nMaxFileTitle
        push    ecx                                                      ;lpstrFileTitle
        push    edx                                                      ;nMaxFile
        push    eax                                                      ;lpstrFile
        push    1                                                        ;nFilterIndex
        push    ecx                                                      ;nMaxCustFilter
        push    ecx                                                      ;lpstrCustomFilter
        push    offset FileTypeStrs                                      ;lpstrFilter
        push    hInstance                                                ;hInstance
        push    hWin                                                     ;hwndOwner
        push    76                                                       ;lStructSize
        mov     OfnFlag,ecx
        INVOKE  GetOpenFileName,esp
        add     esp,76                                                   ;sizeof OPENFILENAME
        xor     eax,eax
        pop     edx                                                      ;EDX = address of allocated block
        pop     ecx                                                      ;ECX = size of allocated block
        cmp     al,[edx]
        jz      no_filename

;open file code goes here
;we'll just show the filename (pointed to by EDX) in a message box

        INVOKE  MessageBox,NULL,edx,offset szOpen,MB_OK

no_filename:
        CALL    HFree
        ret

FOpen   ENDP

;***********************************************************************************************

_main   PROC

;------------------------------

;initialize common controls

        xor     edi,edi                                 ;EDI = 0
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp

;------------------------------

;initialize the process heap handle

        INVOKE  GetProcessHeap
        mov     hHeap,eax

;------------------------------

;register the window class

        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax
        xchg    eax,ebp                                 ;EBP = hInstance
        INVOKE  LoadIcon,ebp,IDI_ICON
        xchg    eax,ebx                                 ;EBX = hIcon
        INVOKE  LoadCursor,edi,IDC_ARROW                ;EAX = hCursor
        mov     esi,offset szClassName                  ;ESI = offset szClassName
        push    ebx                                     ;WNDCLASSEX.hIconSm
        push    esi                                     ;WNDCLASSEX.lpszClassName
        push    edi                                     ;WNDCLASSEX.lpszMenuName
        push    COLOR_SCROLLBAR+1                       ;WNDCLASSEX.hbrBackground
        push    eax                                     ;WNDCLASSEX.hCursor
        push    ebx                                     ;WNDCLASSEX.hIcon
        push    ebp                                     ;WNDCLASSEX.hInstance
        push    edi                                     ;WNDCLASSEX.cbWndExtra
        push    edi                                     ;WNDCLASSEX.cbClsExtra
        push    WndProc                                 ;WNDCLASSEX.lpfnWndProc
        push    edi                                     ;WNDCLASSEX.style
        push    sizeof WNDCLASSEX                       ;WNDCLASSEX.cbSize
        INVOKE  RegisterClassEx,esp

;ESI = offset szClassName
;EDI = 0
;EBP = hInstance

;------------------------------

;create the menu

        push    esi
        push    ebp

        INVOKE  CreateMenu
        mov     hMenu,eax
        or      edi,MAINMENU_QTY                        ;main menu item qty EQU 4
        mov     esi,offset MenuTable
        xchg    eax,ebx                                 ;EBX = hMenu

MMenu0: INVOKE  CreatePopupMenu
        push    eax
        lodsd
        xchg    eax,ebp

MMenu1: pop     edx
        lodsd
        push    edx
        push    eax
        lodsd
        push    eax
        lodsd
        push    eax
        push    edx
        CALL    AppendMenu
        dec     ebp
        jnz     MMenu1

        pop     edx
        lodsd
        push    edx
        INVOKE  AppendMenu,ebx,MF_POPUP,edx,eax
        dec     edi
        jnz     MMenu0

        pop     ecx                                     ;ECX = Help menu handle
        pop     ebp                                     ;EBP = View menu handle
        pop     edx                                     ;EDX = Edit menu handle
        pop     eax                                     ;EAX = File menu handle

;EBX = hMenu
;EDI = 0

        pop     ebp
        pop     esi

;ESI = offset szClassName
;EBP = hInstance

;------------------------------

;create the window

        INVOKE  CreateWindowEx,edi,esi,offset szAppName,
                WS_OVERLAPPEDWINDOW or WS_VISIBLE or WS_CLIPCHILDREN,
                CW_USEDEFAULT,SW_SHOWNORMAL,400,300,edi,ebx,ebp,edi
        mov     hWin,eax
        INVOKE  UpdateWindow,eax

;------------------------------

;message loop

        mov     ebp,esp                                 ;EBP = offset MSG
        jmp short mLoop1

mLoop0: INVOKE  TranslateMessage,ebp
        INVOKE  DispatchMessage,ebp

mLoop1: INVOKE  GetMessage,ebp,edi,edi,edi
        inc     eax                                     ;exit only
        shr     eax,1                                   ;if 0 or -1
        jnz     mLoop0                                  ;otherwise, we loop

;------------------------------

;exit program

        pop     eax                                     ;MSG.wParam is the parm for ExitProcess
        JMP     ExitProcess

_main   ENDP

;###############################################################################################

        END     _main

